Subject: Bug in if... then if... parsing
From: Bart Schaefer <[email-masked]>
To: [email-masked]
Date: Sun, 6 Mar 2016 14:27:31 -0800
List-Id: Zsh Workers List <zsh-workers.zsh.org>

Reproducible at least as long ago as zsh-4.2.0.

Consider:

torch% x () {
function> if false
function if> then
function then> x=1
function then> elif true
function elif> then
function elif-then> if :
function elif-then if> else
function else> :
function else> fi
function> }
torch% 

Here it is without the PS2 prompts:

x () {
    if false
    then
        x=1
    elif true
    then
        if :
    else
        :
    fi
}

This should be a parse error --

torch% if :
if> else
zsh: parse error near `else'
torch% 

-- but instead it's accepted, the parser has somehow implied the
"missing" then/fi with a blank line between:

torch% functions -x4 x
x () {
    if false
    then
        x=1 
    elif true
    then
        if :
        then
            
        fi
    else
        :
    fi
}
torch% 

I was at one point able to get the parser into a state where this caused a
correct structure to syntax error because this weird implicit "fi" doubled
an actual "fi", but it was in the context of a larger function and I lost
it from my terminal scrollback by the time I worked out that it wasn't
something I was doing wrong.  It had something to do with "then" appearing
with other code on the same line rather than on a line by itself.

As far as I can tell this only happens when "if" immediately follows "then".
At first I thought the "elif" was also required, but no:

torch% if :
if> then
then> if :
then if> else
else> fi
torch%